
\usepackage{url}
\urlstyle{sf} %% Options: tt/rm/sf/same
\usepackage{xcolor}
\usepackage{fp}
\usepackage{pgfmath}

% Images
%\usepackage{graphicx} %already included in main file
\usepackage{lscape}
%\usepackage{picins}
\usepackage{floatflt}
\usepackage{wrapfig}

% Mathematical symbols
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
%\usepackage[utf8]{inputenc}
\usepackage{upgreek}

% Typography helpers
\usepackage{microtype}
\usepackage{units}
\usepackage{fancyvrb}
\usepackage{ragged2e}
\usepackage{mdframed}
\usepackage{multirow}
%\usepackage{xfrac} %clashed with graphicx in EGSR 2019 template
%\usepackage{flushend} %equalize last-page columns

% Pseudocode
\usepackage{algorithm}
\usepackage{algorithmicx}
\usepackage{algpseudocode}
\usepackage{units}
\usepackage{booktabs}
\usepackage{listings}
\usepackage{verbatim}
\DeclareMathAlphabet{\mathcal}{T1}{pzc}{mb}{it}

\definecolor{superred}{rgb}{1,0,0}
\definecolor{codegrey}{rgb}{0.95,0.95,0.95}
\definecolor{colKeys}{rgb}{0,0.2,0.4}
\definecolor{colKeys2}{rgb}{0,0.8,0}
\definecolor{colIdentifier}{rgb}{0,0,0}
\definecolor{colComments}{rgb}{0,0.6,0}
\definecolor{colString}{rgb}{0.6,0.1,0.1}

\lstset{
	language=C++,
	keywordstyle=\color{blue},
	basicstyle=\small\ttfamily,
	commentstyle=\color{green}\ttfamily,
	stringstyle=\rmfamily,
	numbers=none,
	numberstyle=\tiny\ttfamily,
	stepnumber=1,
	numbersep=8pt,
	showstringspaces=false,
	breaklines=true,
	frameround=ftff,
	frame=single,
	belowcaptionskip=.75\baselineskip,
	tabsize=4,
}
\newcounter{thelisting}
\newenvironment{listing}[1] {
	\begin{figure}[htb]
	}{
\end{figure}
}

% Custom section/figure/etc. wrappers
\def\mychapter#1#2{\chapter{#1}\label{ch:#2}}
\def\mysection#1#2{\section{#1}\label{sec:#2}}
\def\mysubsection#1#2{\subsection{#1}\label{sec:#2}}
\def\mysubsubsection#1#2{\subsubsection{#1}\label{sec:#2}}

\def\negspace{\vspace{-6pt}}
\def\negspaceB{\vspace{-15pt}}
% Single/double-column figure macros {name}{caption}
\def\myfigure#1#2{\begin{figure}[thp]\centering\includegraphics*[width = \linewidth]{img/#1}\negspace{}\caption{#2}\negspaceB\label{fig:#1}\end{figure}}
\def\myfigureDouble#1#2{\begin{figure*}[t]\centering\includegraphics*[clip, width = \linewidth]{img/#1}\negspace{}\caption{#2}\negspaceB\label{fig:#1}\end{figure*}}
% Configurable single/double-column figure macros {name}{position}{relwidth}{caption}
\def\myfigureCustom#1#2#3#4{\begin{figure}[#2]\centering\includegraphics*[width = #3\linewidth]{img/#1}\negspace{}\caption{#4}\negspaceB\label{fig:#1}\end{figure}}
\def\myfigureCustomDouble#1#2#3#4{\begin{figure*}[#2]\centering\includegraphics*[clip, width = #3\linewidth]{img/#1}\negspace{}\caption{#4}\negspaceB\label{fig:#1}\end{figure*}}

\def\myitem#1{\item\label{item:#1}}
\def\Par#1{\paragraph*{#1.}}
%\def\Par#1{\vspace{0.2cm}\textbf{#1}\hspace{0.5em}}

% \def\refFigure#1{Fig.\,\ref{fig:#1}}
% \def\refFig#1{Fig.\,\ref{fig:#1}}
% \def\refFigNum#1{\ref{fig:#1}}
% \def\refChapter#1{Chap.\,\ref{ch:#1}}
% \def\refChap#1{Chap.\,\ref{ch:#1}}
% \def\refSection#1{Sec.\,\ref{sec:#1}}
% \def\refSec#1{Sec.\,\ref{sec:#1}}
% \def\refAppendix#1{Apx.\,\ref{sec:#1}}
% \def\refApx#1{Apx.\,\ref{sec:#1}}
% \def\refApp#1{Apx.\,\ref{app:#1}}
% \def\refTable#1{Table~\ref{tbl:#1}}
% \def\refTab#1{Table~\ref{tbl:#1}}
% \def\refEquation#1{Eq.\,\ref{eq:#1}}
% \def\refEqn#1{Eq.\,\ref{eq:#1}}
% \def\refEq#1{Eq.\,\ref{eq:#1}}
% \def\refListing#1{Listing~\ref{lst:#1}}
% \def\refItem#1{Item~\ref{item:#1}}
% \def\refCategory#1{Category~\ref{item:#1}}
% \def\refStep#1{Step~\ref{item:#1}}
% \def\refAlg#1{Algorithm~\ref{alg:#1}}

% \def\refChapters#1#2{Chaps.\,\ref{ch:#1}~and~\ref{ch:#2}}
% \def\refChaps#1#2{Chaps.\,\ref{ch:#1}~and~\ref{ch:#2}}
% \def\refSections#1#2{Secs.\,\ref{sec:#1}~and~\ref{sec:#2}}
% \def\refSecs#1#2{Secs.\,\ref{sec:#1}~and~\ref{sec:#2}}
% \def\refCategories#1#2{Categories~\ref{item:#1}~and~\ref{item:#1}}
% \def\refCategories#1#2#3{Categories~\ref{item:#1},~\ref{item:#2}~and~\ref{item:#3}}
% \def\refEqs#1#2{Eqs.\,\ref{eq:#1}~and~\ref{eq:#2}}
% \def\refEqss#1#2#3{Eqs.\,\ref{eq:#1},~\ref{eq:#2}~and~\ref{eq:#3}}
% \def\refEquations#1#2{Eqs.\,\ref{eq:#1}~and~\ref{eq:#2}}
% \def\refFigs#1#2{Figs.\,\ref{fig:#1}~and~\ref{fig:#2}}
% \def\refFigss#1#2#3{Figs.\,\ref{fig:#1},~\ref{fig:#2}~and~\ref{fig:#3}}

% \def\refFigureRange#1#2{Figs.\,\ref{fig:#1}--\ref{fig:#2}}
% \def\refChapterRange#1#2{Chaps.\,\ref{ch:#1}--\ref{ch:#2}}
% \def\refSectionRange#1#2{Secs.\,\ref{sec:#1}--\ref{sec:#2}}
% \def\refTableRange#1#2{Tables~\ref{tbl:#1}--\ref{tbl:#2}}
% \def\refStepsRange#1#2{Steps~\ref{item:#1}--\ref{item:#2}}

\def\refFigure#1{Figure~\ref{fig:#1}}
\def\refFig#1{Figure~\ref{fig:#1}}
\def\refFigNum#1{\ref{fig:#1}}
\def\refChapter#1{Chapter~\ref{ch:#1}}
\def\refChap#1{Chapter~\ref{ch:#1}}
\def\refSection#1{Section~\ref{sec:#1}}
\def\refSec#1{Section~\ref{sec:#1}}
\def\refAppendix#1{Appendix~\ref{sec:#1}}
\def\refApx#1{Appendix~\ref{sec:#1}}
\def\refApp#1{Appendix~\ref{app:#1}}
\def\refTable#1{Table~\ref{tbl:#1}}
\def\refTab#1{Table~\ref{tbl:#1}}
\def\refEquation#1{Equation~\ref{eq:#1}}
\def\refEqn#1{Equation~\ref{eq:#1}}
\def\refEq#1{Equation~\ref{eq:#1}}
\def\refListing#1{Listing~\ref{lst:#1}}
\def\refItem#1{Item~\ref{item:#1}}
\def\refCategory#1{Category~\ref{item:#1}}
\def\refStep#1{Step~\ref{item:#1}}
\def\refAlg#1{Algorithm~\ref{alg:#1}}

\def\refChapters#1#2{Chapters~\ref{ch:#1}~and~\ref{ch:#2}}
\def\refChaps#1#2{Chapters~\ref{ch:#1}~and~\ref{ch:#2}}
\def\refSections#1#2{Sections~\ref{sec:#1}~and~\ref{sec:#2}}
\def\refSecs#1#2{Sections~\ref{sec:#1}~and~\ref{sec:#2}}
\def\refCategories#1#2{Categories~\ref{item:#1}~and~\ref{item:#1}}
\def\refCategories#1#2#3{Categories~\ref{item:#1},~\ref{item:#2}~and~\ref{item:#3}}
\def\refEqs#1#2{Equations~\ref{eq:#1}~and~\ref{eq:#2}}
\def\refEqss#1#2#3{Equations~\ref{eq:#1},~\ref{eq:#2}~and~\ref{eq:#3}}
\def\refEquations#1#2{Equations~\ref{eq:#1}~and~\ref{eq:#2}}
\def\refFigs#1#2{Figures~\ref{fig:#1}~and~\ref{fig:#2}}
\def\refFigss#1#2#3{Figures~\ref{fig:#1},~\ref{fig:#2}~and~\ref{fig:#3}}

\def\refFigureRange#1#2{Figures~\ref{fig:#1}--\ref{fig:#2}}
\def\refChapterRange#1#2{Chapters~\ref{ch:#1}--\ref{ch:#2}}
\def\refSectionRange#1#2{Sections~\ref{sec:#1}--\ref{sec:#2}}
\def\refEquationRange#1#2{Equations~\ref{eq:#1}--\ref{eq:#2}}
\def\refTableRange#1#2{Tables~\ref{tbl:#1}--\ref{tbl:#2}}
\def\refStepsRange#1#2{Steps~\ref{item:#1}--\ref{item:#2}}

% Custom lists
\newcounter{myEnumCounter}
\newenvironment{myenum}
{
	\setcounter{myEnumCounter}{0}
	\begin{list}
	{
		\arabic{myEnumCounter}.
	}{
		\usecounter{myEnumCounter}
		\leftmargin=1.5em
		\labelsep=0.2em
		\topsep=0.4em
		\parsep=0em
		\itemsep=0.1em
	}
}{
	\end{list}
}

\newenvironment{myitemize}
{
	\begin{list}{\labelitemi}
	{
		\leftmargin=1.5em
		\parskip=0.15em
		\itemsep=0.1em
		\topsep=0.1em
		\parsep=0.1em
	}
}{
	\end{list}
	\vspace{0.3em}
}

% Corrections, notes
\definecolor{todocolor}{RGB}{180,50,30}
\definecolor{commentColor}{RGB}{50,120,20}
\definecolor{darkyellow}{RGB}{160,140,10}
\definecolor{darkgreen}{rgb}{0.05,0.4,0.05}
\definecolor{orange}{RGB}{200,100,0}

% COMMENT SWITCH
\newcommand{\XComment}[3]{\textcolor{#2}{{[\textbf{#1:} \textsl{#3}}]}}
%\newcommand{\XComment}[3]{}

\newcommand{\cAF}[1]{\XComment{JK}{magenta}{#1}}
\newcommand{\cMT}[1]{\XComment{SH}{blue}{#1}}
\newcommand{\cOE}[1]{\XComment{OE}{orange}{#1}}
\newcommand{\TODO}[1]{\XComment{TODO}{todocolor}{#1}}
\newcommand{\change}[1]{{\color{darkgreen}#1}} % For revised versions
%\newcommand{\change}[1]{{#1}}
\newcommand{\IGNORE}[1]{}

% Abbreviations, shortcuts
\def\naive{na\"ive}
\def\Naive{Na\"ive}
\def\wrt{w.\,r.\,t.\,}
\def\eg{e.\,g., }
\def\ie{i.\,e., }
\def\etc{etc.\,}
\def\fin{f.\,i.\,}
\def\etal{et~al.\ }
\def\cf{cf.\ }
\def\citeetal#1{et~al.~\shortcite{#1}}
\def\shortciteetal#1{et~al.~\shortcite{#1}}

% Operators, symbols...
\def\mrm#1{\mathrm{#1}}
\def\mathsbf#1{\textsf{\textbf{#1}}}
\def\mathsf#1{\textsf{#1}}
\newcommand{\myvec}[1]{\mathbf{#1}}
\newcommand{\mypt}[1]{\mathbf{#1}}
\newcommand{\mymat}[1]{\mathbf{#1}}
\newcommand{\myray}[1]{\mathbf{#1}}
\newcommand{\field}[1]{\mathsf{#1}}
\newcommand{\img}[1]{\mathsf{#1}}
\def\domain#1{{\mathcal{D}^{#1}}}
\def\dimension{{d}}

\newcommand{\pardif}[1]{\frac{\partial #1}{\partial \lambda}}
\providecommand{\abs}[1]{\lvert#1\rvert}
\providecommand{\norm}[1]{\lVert#1\rVert}
\def\dd#1{~\mathrm{d}#1}
\newcommand{\argmax}{\operatornamewithlimits{arg\,max}}
\newcommand{\argmin}{\operatornamewithlimits{arg\,min}}
\DeclareMathOperator{\ortho}{ortho}
\def\OH#1{\mathcal{O}(#1)}
\def\hemiUp{\mathcal{H}}
\def\sphere{\mathcal{S}}
\def\real{\mathbb{R}}

\newcommand{\gauss}{\operatorname{\mathcal{N}}}
\newcommand{\gmm}{\operatorname{\mathcal{G}}}
\DeclareMathOperator{\brdf}{\rho}
\newcommand{\pdf}{\operatorname{\mathcal{p}}}
\newcommand{\pdfBrdf}{\operatorname{\mathcal{p}_{\brdf}}}
\newcommand{\pdfLight}{\operatorname{\mathcal{p}_{L}}}
\newcommand{\pdfProd}{\operatorname{\mathcal{p}_{\otimes}}}
\newcommand{\expected}[1]{\operatorname{E}[#1]}
\newcommand{\variance}[1]{\operatorname{Var}[#1]}
\newcommand{\vmf}{\operatorname{\mathcal{v}}}
\newcommand{\vmm}{\operatorname{\mathcal{V}}}
\newcommand{\phase}{\operatorname{\mathcal{f}}}

\newcommand{\product}{\operatorname{\otimes}}
\newcommand{\convolve}{\operatorname{\ast}}
%\newcommand{\convolve}{\operatorname{\circledast}}

\newcommand{\mis}{\beta}
\newcommand{\misPhase}{\mySub{\mis}{\phase}}
\newcommand{\misDist}{\mySub{\mis}{d}}

\newcommand{\radiance}{L} %radiance
\def\radianceEmit{\radiance_\mathrm{E}}
\def\radianceRefl{\radiance_\mathrm{R}}
\def\radianceEst{\widehat{L}}
\def\radianceEstRefl{\radianceEst_\mathrm{R}}

\newcommand{\InRadiance}{L}
\newcommand{\InscatRadiance}{L_i}

\newcommand{\relMSE}{\operatorname{relMSE}}

\newcommand{\pt}[1]{#1}		%point/position
\newcommand{\pti}[2]{\pt{#1}_\mathrm{#2}} %point/position with index
\newcommand{\dirW}{\myvec{\omega}}	% direction omega
\newcommand{\dirWsub}[1]{\myvec{\omega}_\mathrm{#1}}	%direction omega with subscript
\newcommand{\dirWIdx}[1]{\myvec{\omega}_{#1}}	%direction omega with index

\newcommand{\myVecSub}[2]{\myvec{#1}_\mathrm{#2}}
\newcommand{\myVecIdx}[2]{\myvec{#1}_{#2}}
\newcommand{\mySub}[2]{#1_\mathrm{#2}}
\newcommand{\myIdx}[2]{#1_{#2}}

\newcommand{\myW}{a}
\newcommand{\myRayW}{\myW}
%\newcommand{\mySegW}[2]{\myW(#1 \rightarrow #2)}
\newcommand{\mySegW}[2]{\myW(\myIdx{\mypt{x}}{#1},\myIdx{\dirW}{#1} | \myIdx{\mypt{x}}{#2},\myIdx{\dirW}{#2})}

\newcommand{\prob}{P} % pdf for a scattering event
\newcommand{\pdfDir}{\mySub{\pdf}{\dirW}}	%pdf for a scattering direction
\newcommand{\pdfDist}{\mySub{\pdf}{d}}	%pdf for the scattering distance
\newcommand{\pdfScat}{\mySub{\pdf}{m}} % pdf for a scattering event
\newcommand{\probScat}{\mySub{\prob}{m}} % pdf for a scattering event
\newcommand{\probRR}{\mySub{\prob}{RR}} % pdf for a scattering event
\newcommand{\approxInRadiance}{\tilde{\InRadiance}}   
\newcommand{\approxInscatRadiance}{\tilde{\InscatRadiance}}   

\newcommand{\myL}{L}				% incomming radiance
\newcommand{\myLi}{\mySub{L}{i}} % in-scattered volume radiance
\newcommand{\myLe}{\mySub{L}{e}} % in-scattered volume radiance
\newcommand{\myLo}{\mySub{L}{o}} % out-scattered surface radiance
\newcommand{\myLr}{\mySub{L}{r}} % out-scattered surface radiance
\newcommand{\myEstL}{\tilde{\myL}} % in-scattered volume radiance
\newcommand{\myEstLi}{\mySub{\tilde{L}}{i}} % out-scattered surface radiance
\newcommand{\myEstLe}{\mySub{\tilde{L}}{e}} % out-scattered surface radiance
\newcommand{\myLs}{\mySub{L}{s}}
\newcommand{\myLm}{\mySub{L}{m}}

\newcommand{\est}[1]{\widehat{#1}}
\newcommand{\myE}{E}
\newcommand{\Exp}[1]{\mathrm{E}[#1]}
\newcommand{\Var}[1]{\mathrm{Var}[#1]}
\newcommand{\Cov}[1]{\mathrm{Cov}[#1]}
\newcommand{\model}{\mathcal{M}}
\newcommand{\loss}{\uplambda}
\newcommand{\var}[1]{\upnu_{#1}}

\newcommand{\inRadiance}[2]{{\InRadiance}(#1,\myvec{#2})}
\newcommand{\inscatRadiance}[2]{{\InscatRadiance}(#1,\myvec{#2})}

\def\sigmaT{\mySub{\sigma}{t}}
\def\sigmaS{\mySub{\sigma}{s}}
\def\sigmaA{\mySub{\sigma}{a}}
\def\albedo{\alpha}

%% Adjoint driven RR and splitting
\newcommand{\adjoint}{\Psi}                        % adjoint solution
\newcommand{\referenceSolution}{R\xspace}          % reference solution
\newcommand{\solution}{I}                          % expected value of the estimator
\newcommand{\approxSolution}{\tilde{I}}            % expected value of the estimator
\newcommand{\prior}{\lambda}

\def\posX{\myvec{x}}
\def\dirX{\myvec{\omega}}
\def\pos#1#2{\posX_\mathrm{#1}^\mathrm{#2}}
\def\dir#1#2{\dirX_\mathrm{#1}^\mathrm{#2}}
\def\posY{\pos{}{\prime}}
\def\dirY{\dir{}{\prime}}
\def\dirI{\dir{i}{}}
\def\dirO{\dir{o}{}}

\def\percent#1{#1\,\%}
\def\degrees#1{#1\ensuremath{^\circ}}
\def\resolution#1#2{{#1\textsuperscript{#2}}}
\def\resolutionX#1#2{{#1}$\times${#2}}

\def\bathroomScene{\textsc{Bathroom}}
\def\whiteroomScene{\textsc{WhiteRoom}}
\def\nightroomScene{\textsc{NightRoom}}
\def\futuroScene{\textsc{MeasureOne}}

\def\corona{\textsc{LivingRoom}}
\def\kitchenTwo{\textsc{Kitchen}}
\def\necklace{\textsc{Jewelry}}
\def\kitchen{\textsc{Kitchenette}}

\def\headScene{\textsc{InfiniteScan Head}}
\def\museumScene{\textsc{Natural History}}
\def\causticScene{\textsc{Volume Caustic}}
\def\buddhaScene{\textsc{Buddha}}
\def\bumpyScene{\textsc{Bumpy Sphere}}
\def\heteroCubeScene{\textsc{Checkerboard Cube}}

% Pimp up Greek letters
%\renewcommand{\lambda}{\uplambda}
%\renewcommand{\gamma}{\upgamma}
%\renewcommand{\alpha}{\upalpha}
%\renewcommand{\epsilon}{\upepsilon}
%\renewcommand{\rho}{\uprho}
%\renewcommand{\vartheta}{\upvartheta}
%\renewcommand{\eta}{\upeta}
%\renewcommand{\beta}{\upbeta}
%\renewcommand{\mu}{\upmu}
%\renewcommand{\nu}{\upnu}
%\renewcommand{\omega}{\upomega}
%\renewcommand{\Omega}{\Upomega}
%\renewcommand{\sigma}{\upsigma}
%\renewcommand{\tau}{\uptau}
%\renewcommand{\theta}{\uptheta}
%\renewcommand{\Theta}{\Uptheta}
%\renewcommand{\Sigma}{\Upsigma}
%\renewcommand{\phi}{\upphi}
%\renewcommand{\pi}{\uppi}
%\renewcommand{\xi}{\upxi}
%\renewcommand{\delta}{\updelta}

% function names
\newcommand{\fGamma}{Ga}
\newcommand{\fInvGamma}{IGa}
\newcommand{\fWishart}{Wi}
\newcommand{\fInvWishart}{IWi}
\newcommand{\fInvChiS}{IChi^{2}}

\newcommand{\Tr}[2]{T(#1,#2)}
\newcommand{\fexp}[1]{e^{#1}}

\newcommand{\RNum}[1]{\uppercase\expandafter{\romannumeral #1\relax}}
